import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.sql.DriverManager;

import javax.imageio.ImageIO;
import javax.swing.*;

import tables.*;

import com.mysql.jdbc.StringUtils;

import java.sql.*;
import java.util.Calendar;

import database_connection.DBMySQLConnection;


public class DBGUI extends JFrame {
	
	private static final long serialVersionUID = -1282222959410151696L;

	private JPanel panelDestro = new JPanel(new GridLayout(15,2));
	private JPanel panelNord = new JPanel();
	private JPanel panelSouth = new JPanel();
	private JPanel PanelCentro = new JPanel(new BorderLayout());
	private JPanel panelCentroButton = new JPanel(new GridLayout(14,1));
	private JPanel panelCentroTable = new JPanel(new GridLayout(0,1));
	private JScrollPane scroll = new JScrollPane(panelCentroTable);
	private JPanel panelSinistro = new JPanel(new GridLayout(10,2));
	
	private JButton aggPalestra = new JButton("Palestra");
	private JButton aggAtleti = new JButton("Atleti");
	private JButton aggGara = new JButton("Gara");
	private JButton aggTatami = new JButton("Tatami");
	private JButton aggCategoria = new JButton("Categoria");
	private JButton aggProva = new JButton("Prova");
	private JButton aggArbitro = new JButton("Arbitro");
	private JButton aggGiudiceInTavoloGiuria = new JButton("Giudice in giuria");
	private JButton aggTavoloGiuria = new JButton("Tavolo di giuria");
	private JButton aggKata = new JButton("Kata");
	private JButton aggGiudice = new JButton("Giudice");
	private JButton add = new JButton("Aggiungi");
	private JButton remove = new JButton("Rimuovi");
	private JButton change = new JButton("Modifica");
	private JButton find = new JButton("Cerca");
	private JButton reset = new JButton("Reset");
	
	private JButton atletiFromPalestra = new JButton("Atleti di una palestra");
	private JButton dettagliGaraAtleta = new JButton("Dettagli gara di un atleta");
	private JButton atletiCFDaNome = new JButton("Atleti con un certo nome");
	private JButton giudiceDaCF = new JButton("Anagrafica di un certo giudice");
	private JButton tuttiKata = new JButton("Nomi di tutti i Kata");
	private JButton tuttaGiuria = new JButton("Codici dei tavoli di Giuria");
	private JButton tutteCategorie = new JButton("Lista delle categorie");
	private JButton nomePalestraDaCittà = new JButton("Nomi delle palestra in una città");
	private JButton contaAtletiCategoria = new JButton("Numero di atleti di una categoria");
	private JButton giudiceInGiuria = new JButton("Dati anagrafici giudici in una giuria");
	private JButton atletiSuTatami = new JButton("Atleti da un tatami");
	private JButton nomeManifestazioneDaPalestra = new JButton("Nomi manifestazioni in una palestra");
	private JButton sommaVoti = new JButton("Somma voti ottenuti da un atleta");
	private JButton risultati = new JButton("Voto massimo per categoria");
	private JLabel FindDescrition = new JLabel("CERCA IN BASE A :");
	private JLabel[] label = new JLabel[10];

	private final athletTable athlets = new athletTable();
	private final GymTable gym = new GymTable();
	private final KataTable kata = new KataTable();
	private final RefreeTable refree = new RefreeTable();
	private final PerformanceTable performance = new PerformanceTable();
	private final JudgeTable judge = new JudgeTable();
	private final JuryTable jury = new JuryTable();
	private final CompetitionTable competition = new CompetitionTable();
	private final TatamiTable tatami = new TatamiTable();
	private final CategoryTable category = new CategoryTable();
	private final JudgeJuryTable jjtable = new JudgeJuryTable();
	
	private JTextField[] text = new JTextField[10];

	private final DBMySQLConnection dbConnection = new DBMySQLConnection();
	private final boolean root;
	JLabel sfondo = new JLabel (new ImageIcon(ImageIO.read(this.getClass().getResource("/sfondo.png"))));
	
	public DBGUI(boolean permission) throws Exception{

		super();
		root = permission;
		this.add(sfondo);
		this.setContentPane(sfondo);
		this.setSize((int)(Toolkit.getDefaultToolkit().getScreenSize().getWidth()/1.5),(int) ((int)Toolkit.getDefaultToolkit().getScreenSize().getHeight()/1.5));
		this.setVisible(true);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setResizable(false);
		sfondo.setLayout(new BorderLayout());
		panelDestro.setOpaque(false);
		
		Dimension dim =Toolkit.getDefaultToolkit().getScreenSize();
		this.setLocation((int)dim.getWidth()/2 - this.getSize().width/2,(int)dim.getHeight()/2-this.getSize().height/2);
		
		sfondo.add(panelDestro,BorderLayout.WEST);
		sfondo.add(panelNord,BorderLayout.NORTH);
		sfondo.add(panelSinistro,BorderLayout.EAST);
		sfondo.add(PanelCentro,BorderLayout.CENTER);
		sfondo.add(panelSouth,BorderLayout.SOUTH);
	
		panelNord.add(add);
		panelNord.add(remove);
		panelNord.add(change);
		panelNord.add(find);
		panelNord.add(reset);
		panelNord.setOpaque(false);
		
		for(int i=0;i<10;i++){
			label[i]= new JLabel("");
			label[i].setVisible(false);
			text[i]= new JTextField(10);
			text[i].setVisible(false);
			panelSinistro.add(label[i]);
			panelSinistro.add(text[i]);
		}
		panelSinistro.setOpaque(false);
		
		panelDestro.add(aggPalestra);
		panelDestro.add(aggAtleti);
		panelDestro.add(aggArbitro);
		panelDestro.add(aggKata);
		panelDestro.add(aggGara);
		panelDestro.add(aggTatami);
		panelDestro.add(aggProva);	
		panelDestro.add(aggCategoria);
		panelDestro.add(aggGiudice);
		panelDestro.add(aggTavoloGiuria);
		panelDestro.add(aggGiudiceInTavoloGiuria);
		
		PanelCentro.setOpaque(false);
		PanelCentro.add(panelCentroButton,BorderLayout.WEST);
		panelCentroButton.setOpaque(false);
		PanelCentro.add(scroll);
		panelCentroTable.setOpaque(false);
		scroll.setOpaque(false);

		FindDescrition.setForeground(Color.BLACK);
		panelCentroButton.add(atletiFromPalestra);
		panelCentroButton.add(dettagliGaraAtleta);
		panelCentroButton.add(atletiCFDaNome);
		panelCentroButton.add(giudiceDaCF);
		panelCentroButton.add(tuttiKata);
		panelCentroButton.add(tuttaGiuria);
		panelCentroButton.add(tutteCategorie);
		panelCentroButton.add(nomePalestraDaCittà);
		panelCentroButton.add(contaAtletiCategoria);
		panelCentroButton.add(giudiceInGiuria);
		panelCentroButton.add(atletiSuTatami);
		panelCentroButton.add(nomeManifestazioneDaPalestra);
		panelCentroButton.add(sommaVoti);
		panelCentroButton.add(risultati);
		
		eraseCenter();
		if(!root){
			add.setEnabled(false);
			remove.setEnabled(false);
			change.setEnabled(false);
		}
		

	  aggPalestra.addActionListener(e->{ 

	    inizializza(aggPalestra,new String[]{"numero posti","indirizzo","C_nome palestra","città"});	
	  });
	  
	  aggAtleti.addActionListener(e->{
	    inizializza(aggAtleti,new String[]{"luogo di nascita","data di nascita","cognome","nome","C_codice fiscale","grado dan","sesso","nome palestra","citta palestra","nome categoria"});
	  });
			
	  aggArbitro.addActionListener(e->{
	    inizializza(aggArbitro,new String[]{"luogo nascita","data di nascita","cognome","nome","C_codice fiscale","nome palestra","cita palestra"});
	  });
	  
	  aggTavoloGiuria.addActionListener(e -> {
		  inizializza(aggTavoloGiuria, new String[]{"C_codice"});
	  });
		
	  aggCategoria.addActionListener(e->{
	    inizializza(aggCategoria,new String[]{"C_Categoria"});
	  });
	
	  aggProva.addActionListener(e->{
		inizializza(aggProva,new String[]{"C_Nome kata","C_codice fiscale atleta","C_nome Prova","categoria","codice fiscale arbitro","codice tatami","voto"});
	  });
	  aggGiudiceInTavoloGiuria.addActionListener(e-> {
		  inizializza(aggGiudiceInTavoloGiuria, new String[]{"C_codice fiscale giudice","C_codice tavolo di giuria"});
	  });
	
	  aggTatami.addActionListener(e->{
	    inizializza(aggTatami,new String[]{"nome palestra","citta palestra","C_codice","codice tavolo giuria"}); 
	  });
	  
	  aggKata.addActionListener(e->{
		  inizializza(aggKata,new String[]{"C_nome kata"});
	  });
	  
	  aggGiudice.addActionListener(e-> {

		  inizializza(aggGiudice,new String[]{"luogo di nascita","data di nascita","cognome","nome","C_CF","nome palestra","città palestra"});

	  });
	  
	  aggGara.addActionListener(e->{
		  inizializza(aggGara,new String[]{"C_data","nome Manifestazione","C_nome palestra","C_citta palestra"});
	  });
	  
	  find.addActionListener(e->{
		  showCenter();
		  inizializza(new JButton(),new String[0]);
	  });
	  
	  reset();
	  giudiceDaCF.addActionListener(e -> {
		  JDialog dialog = new JDialog();
		  JPanel dialogPanel = new JPanel(new GridLayout(3,1));
		  dialog.setLocation((int)dim.getWidth()/2 - dialog.getSize().width/2,(int)dim.getHeight()/2-dialog.getSize().height/2);
			
		  JLabel area1 = new JLabel("Codice Fiscale giudice: ");
		  JTextField text1 = new JTextField(16);
		  JButton cerca = new JButton("Enter");
		  dialog.add(dialogPanel);
		  dialogPanel.add(area1);
		  dialogPanel.add(text1);
		  dialogPanel.add(cerca);
		  dialog.setVisible(true);
		  dialog.pack();
		  
		  cerca.addActionListener(i -> {
			  panelCentroTable.removeAll();
			  
			  panelCentroTable.add(new JTextArea("giudice trovato"));
			  Judge j = judge.getJudgesByCF(text1.getText());
			  panelCentroTable.add(new JTextArea("nome :"));
			  panelCentroTable.add(new JTextArea(j.getName()));
			  panelCentroTable.add(new JTextArea(""));
			  panelCentroTable.add(new JTextArea("cognome :"));
			  panelCentroTable.add(new JTextArea(j.getSurname()));
			  panelCentroTable.add(new JTextArea(""));
			  panelCentroTable.add(new JTextArea("cf"));
			  panelCentroTable.add(new JTextArea(j.getCf()));
			  panelCentroTable.add(new JTextArea(""));
			  panelCentroTable.add(new JTextArea("data di nascita"));
			  panelCentroTable.add(new JTextArea(""+j.getBirthday()));
			  panelCentroTable.add(new JTextArea(""));
			  panelCentroTable.add(new JTextArea("luogo di nascita:"));
			  panelCentroTable.add(new JTextArea(j.getLocation()));
			  panelCentroTable.add(new JTextArea(""));
			  panelCentroTable.add(new JTextArea("nome palestra :"));
			  panelCentroTable.add(new JTextArea(j.getGymName()));
			  panelCentroTable.add(new JTextArea(""));
			  panelCentroTable.add(new JTextArea("citta palestra"));
			  panelCentroTable.add(new JTextArea(j.getGymCity()));
			  scroll.setViewportView(panelCentroTable);
			  dialog.dispose();
		  });
	  });
	  
	  tuttiKata.addActionListener(e -> {
		  List<Kata> kataGot = kata.getAllKata();
		  panelCentroTable.removeAll();
		  panelCentroTable.add(new JLabel("tutti i kata"));
		  for (Kata k : kataGot) {
			  panelCentroTable.add(new JLabel(""));
			  panelCentroTable.add(new JLabel("nome:"));
			  panelCentroTable.add(new JLabel(k.getName()));
			  panelCentroTable.add(new JLabel("---------------"));
		  }
		  scroll.setViewportView(panelCentroTable);
	  });
	  
	  tuttaGiuria.addActionListener(e-> {
		  List<Jurydesk> juries = new ArrayList<Jurydesk>();
		  juries= jury.getAllDesks();
		  panelCentroTable.removeAll();
		  panelCentroTable.add(new JLabel(""));
		  for (Jurydesk j : juries) {
			  System.out.println(j.getCode());
			  panelCentroTable.add(new JLabel(""));
			  panelCentroTable.add(new JLabel(j.getCode()));
			  panelCentroTable.add(new JLabel("------------"));
		  }
		  scroll.setViewportView(panelCentroTable);
	  });
	  
	  nomePalestraDaCittà.addActionListener(e -> {
		  JDialog dialog = new JDialog();
		  JPanel dialogPanel = new JPanel(new GridLayout(3,1));
			dialog.setLocation((int)dim.getWidth()/2 - dialog.getSize().width/2,(int)dim.getHeight()/2-dialog.getSize().height/2);
			
			JLabel area1 = new JLabel("CittÃ : ");
			JTextField text1 = new JTextField(16);
			JButton cerca = new JButton("Enter");
			dialog.add(dialogPanel);
			dialogPanel.add(area1);
			dialogPanel.add(text1);
			dialogPanel.add(cerca);
			dialog.setVisible(true);
			dialog.pack();
		  
			cerca.addActionListener(i ->{
				 List<String> gymsList = gym.getGymsByCity(text1.getText());
				 panelCentroTable.removeAll();
				 
				 panelCentroTable.add(new JLabel(""));
				 for (String g : gymsList) {
					 panelCentroTable.add(new JLabel(""));
					 panelCentroTable.add(new JLabel("nome Palestra " +(gymsList.indexOf(g)+1) + ":"));
					 panelCentroTable.add(new JLabel(g));
					 panelCentroTable.add(new JLabel("--------"));
				 } 
				 scroll.setViewportView(panelCentroTable);	 
			});
		 
	  });
	  
	  atletiSuTatami.addActionListener(e -> {
		  JDialog dialog = new JDialog();
		  JPanel dialogPanel = new JPanel(new GridLayout(3,1));
			dialog.setLocation((int)dim.getWidth()/2 - dialog.getSize().width/2,(int)dim.getHeight()/2-dialog.getSize().height/2);
			
			JLabel area1 = new JLabel("Tatami: ");
			JTextField text1 = new JTextField(16);
			JButton cerca = new JButton("Enter");
			dialog.add(dialogPanel);
			dialogPanel.add(area1);
			dialogPanel.add(text1);
			dialogPanel.add(cerca);
			dialog.setVisible(true);
			dialog.pack();
			
			cerca.addActionListener(i -> {
				panelCentroTable.removeAll();
				List<String> lista =new ArrayList<String>();
				lista = performance.getAthletsOnTatami(Integer.parseInt(text1.getText()));
				
				panelCentroTable.add(new JLabel("lista atleti "));
				for(String s : lista){
					System.out.println(s);
					panelCentroTable.add(new JLabel(""));
					panelCentroTable.add(new JLabel(s));
					panelCentroTable.add(new JLabel("-----------"));
				}
				scroll.setViewportView(panelCentroTable);
				dialog.dispose();
			});
			
	  });
	  
	  contaAtletiCategoria.addActionListener(e -> {
		  JDialog dialog = new JDialog();
			 JPanel dialogPanel = new JPanel(new GridLayout(3,1));
			dialog.setLocation((int)dim.getWidth()/2 - dialog.getSize().width/2,(int)dim.getHeight()/2-dialog.getSize().height/2);
			
			JLabel area1 = new JLabel("Nome categoria: ");
			JTextField text1 = new JTextField(16);
			JButton cerca = new JButton("Enter");
			dialog.add(dialogPanel);
			dialogPanel.add(area1);
			dialogPanel.add(text1);
			dialogPanel.add(cerca);
			dialog.setVisible(true);
			dialog.pack();
			
			cerca.addActionListener(i -> {
				int number = athlets.getNumberAthletsInCategory(text1.getText());
				panelCentroTable.removeAll();
				
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel("numero" +text1.getText()+":"+number));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				scroll.setViewportView(panelCentroTable);
				dialog.dispose();
			});
	  });
	  
	  dettagliGaraAtleta.addActionListener(e -> {
		 JDialog dialog = new JDialog();
		 JPanel dialogPanel = new JPanel(new GridLayout(3,1));
		dialog.setLocation((int)dim.getWidth()/2 - dialog.getSize().width/2,(int)dim.getHeight()/2-dialog.getSize().height/2);
		
		JLabel area1 = new JLabel("Codice Fiscale atleta: ");
		JTextField text1 = new JTextField(16);
		JButton cerca = new JButton("Enter");
		dialog.add(dialogPanel);
		dialogPanel.add(area1);
		dialogPanel.add(text1);
		dialogPanel.add(cerca);
		dialog.setVisible(true);
		dialog.pack();
		
		cerca.addActionListener(i -> {
			
			panelCentroTable.removeAll();
			List<Performance> perfGot = performance.getPerformanceByAthletCF(text1.getText());
			panelCentroTable.add(new JLabel("gare di"+ text1.getText()));
			panelCentroTable.add(new JLabel(""));
			for (Performance p : perfGot) {
				panelCentroTable.add(new JLabel("nome gara"));
				panelCentroTable.add(new JLabel(p.getPerformanceName()));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel("nome kata"));
				panelCentroTable.add(new JLabel(p.getKataName()));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel("punteggio"));
				panelCentroTable.add(new JLabel(""+p.getVote()));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel("categoria"));
				panelCentroTable.add(new JLabel(p.getCategoryName()));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel("codice tatami"));
				panelCentroTable.add(new JLabel(""+p.getTatamiCode()));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel("CF giudice"));
				panelCentroTable.add(new JLabel(p.getRefreeCF()));
				panelCentroTable.add(new JLabel("-----------"));
				panelCentroTable.add(new JLabel("-----------"));
				scroll.setViewportView(panelCentroTable);
			}
			dialog.dispose();
		});
			
	  });
	  
	  change.addActionListener(e->{
		  reset();
		  
	  });
	  
	  nomeManifestazioneDaPalestra.addActionListener(e -> {
		  JDialog dialog = new JDialog();
			JPanel dialogPanel = new JPanel(new GridLayout(3,1));
			
			dialog.setLocation((int)dim.getWidth()/2 - dialog.getSize().width/2,(int)dim.getHeight()/2-dialog.getSize().height/2);
			
			JLabel area1 = new JLabel ("Nome palestra :");
			JTextField text1 = new JTextField(16);
			JLabel area2 = new JLabel ("CittÃ : ");
			JTextField text2 = new JTextField(20);
			JButton enter = new JButton("Enter");
			  
			dialog.add(dialogPanel);
			dialogPanel.add(area1);
			dialogPanel.add(text1);
			dialogPanel.add(area2);
			dialogPanel.add(text2);
			dialogPanel.add(enter);
			  
			dialog.pack();
			dialog.setVisible(true);
			
			enter.addActionListener(i -> {
				panelCentroTable.removeAll();
				List<Competition> all = competition.getAllCompetitionsByGym(text1.getText(), text2.getText());
				panelCentroTable.add(new JLabel("tutte le gare"));
				for (Competition s : all) {
					System.out.println(s.getCompetitionName());
					panelCentroTable.add(new JLabel(""));
					panelCentroTable.add(new JLabel("gara"+(all.indexOf(s)+1)));
					panelCentroTable.add(new JLabel("------------"));
					panelCentroTable.add(new JLabel("nome competizione :"));
					panelCentroTable.add(new JLabel(""+s.getCompetitionName()));
					panelCentroTable.add(new JLabel("------------"));
					panelCentroTable.add(new JLabel("cittÃ "));
					panelCentroTable.add(new JLabel(""+s.getGymCity()));
					panelCentroTable.add(new JLabel("------------"));
					panelCentroTable.add(new JLabel("nome palestra :"));
					panelCentroTable.add(new JLabel(""+s.getGymName()));
					panelCentroTable.add(new JLabel("------------"));
					panelCentroTable.add(new JLabel("data:"));
					panelCentroTable.add(new JLabel(""+s.getDate()));
					panelCentroTable.add(new JLabel("-------------"));
					panelCentroTable.add(new JLabel(""));
					scroll.setViewportView(panelCentroTable);
				}
				
				dialog.dispose();
			}); 
	  });

	  atletiCFDaNome.addActionListener(e-> {
		  
		JDialog dialog = new JDialog();
		JPanel dialogPanel = new JPanel(new GridLayout(3,1));
		
		dialog.setLocation((int)dim.getWidth()/2 - dialog.getSize().width/2,(int)dim.getHeight()/2-dialog.getSize().height/2);
		
		JLabel area1 = new JLabel ("Nome atleta:");
		JTextField text1 = new JTextField(16);
		JButton enter = new JButton("Enter");
		  
		dialog.add(dialogPanel);
		dialogPanel.add(area1);
		dialogPanel.add(text1);
		dialogPanel.add(enter);
		  
		dialog.pack();
		dialog.setVisible(true);
		
		enter.addActionListener(i->{
			panelCentroTable.removeAll();
			  List<Athletes> athletGot = athlets.getAthletesByName(text1.getText());
			  for (Athletes a : athletGot) {
				  panelCentroTable.add(new JLabel("atleta numero "+(athletGot.indexOf(a)+1)));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel("Cognome:"));
				  panelCentroTable.add(new JLabel(a.getSurname()));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel("Nome:"));
				  panelCentroTable.add(new JLabel(a.getName()));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel("CittÃ :"));
				  panelCentroTable.add(new JLabel(a.getGymCity()));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel("Nome palestra"));
				  panelCentroTable.add(new JLabel(a.getGymName()));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel("CF"));
				  panelCentroTable.add(new JLabel(a.getCf()));
				  panelCentroTable.add(new JLabel("--------------"));
				  scroll.setViewportView(panelCentroTable);
				  System.out.println("CF: "+a.getCf()+", Cognome: "+a.getSurname()+", Palestra: "+a.getGymName()+" "+a.getGymCity());
			  }
			  
			  dialog.dispose();
			  });
		});
		  
	  tutteCategorie.addActionListener(e -> {
		  panelCentroTable.removeAll();
		  List<Category> catList = category.getCategories();
		  panelCentroTable.add(new JLabel("tutte le categorie :"));
		  for (Category c : catList) {
			  panelCentroTable.add(new JLabel("---------"));
			  panelCentroTable.add(new JLabel("Categoria: "+c.getCategoryName()));
			  scroll.setViewportView(panelCentroTable);
		  }
		  
	  });	
	  
	  sommaVoti.addActionListener(e -> {
		  JDialog dialog = new JDialog();
			JPanel dialogPanel = new JPanel(new GridLayout(3,2));

			dialog.setLocation((int)dim.getWidth()/2 - dialog.getSize().width/2,(int)dim.getHeight()/2-dialog.getSize().height/2);
			
			JLabel area1 = new JLabel ("CF Atleta:");
			JTextField text1 = new JTextField (20);
			JButton cerca = new JButton ("Enter");
			dialog.add(dialogPanel);
			dialogPanel.add(area1);
			dialogPanel.add(text1);
			dialogPanel.add(cerca);
			dialog.setVisible(true);
			dialog.pack();
			
			cerca.addActionListener(i -> {
				panelCentroTable.removeAll();
				int somma = performance.getSumVotesAthlet(text1.getText());
				panelCentroTable.add(new JLabel("somma dei voti"));
				panelCentroTable.add(new JLabel("--------------"));
				panelCentroTable.add(new JLabel("somma =" + somma));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				panelCentroTable.add(new JLabel(""));
				scroll.setViewportView(panelCentroTable);
				dialog.dispose();
			});
	  });
	  
	  giudiceInGiuria.addActionListener(e -> {
		  JDialog dialog = new JDialog();
			JPanel dialogPanel = new JPanel(new GridLayout(3,2));

			dialog.setLocation((int)dim.getWidth()/2 - dialog.getSize().width/2,(int)dim.getHeight()/2-dialog.getSize().height/2);
			
			JLabel area1 = new JLabel ("Codice giuria:");
			JTextField text1 = new JTextField ();
			JButton cerca = new JButton ("Enter");
			dialog.add(dialogPanel);
			dialogPanel.add(area1);
			dialogPanel.add(text1);
			dialogPanel.add(cerca);
			dialog.setVisible(true);
			dialog.pack(); 
			cerca.addActionListener(i -> {
				List<Judge> giudici = jjtable.getAllJudgesInJury(text1.getText());
				panelCentroTable.removeAll();
				for(Judge a : giudici){
					
					  panelCentroTable.add(new JLabel(""));
					  panelCentroTable.add(new JLabel(" Dati giudice" + " " + (giudici.indexOf(a)+1)));
					  panelCentroTable.add(new JLabel(""));
					  panelCentroTable.add(new JLabel(" Nome:"));
					  panelCentroTable.add(new JLabel(" "+a.getName()));
					  panelCentroTable.add(new JLabel(""));
					  panelCentroTable.add(new JLabel(" Cognome:"));
					  panelCentroTable.add(new JLabel(" "+a.getSurname()));
					  panelCentroTable.add(new JLabel(""));
					  panelCentroTable.add(new JLabel(" Codice fiscale:"));
					  panelCentroTable.add(new JLabel(" "+a.getCf()));
					  panelCentroTable.add(new JLabel(""));
					  panelCentroTable.add(new JLabel(" Citta palestra:"));
					  panelCentroTable.add(new JLabel(" "+a.getGymCity()));
					  panelCentroTable.add(new JLabel(""));
					  panelCentroTable.add(new JLabel(" Data:"));
					  panelCentroTable.add(new JLabel(" "+a.getBirthday()));
					  panelCentroTable.add(new JLabel(""));
					  panelCentroTable.add(new JLabel(" Nome palestra:"));
					  panelCentroTable.add(new JLabel(" "+a.getGymName()));
					  panelCentroTable.add(new JLabel("-------"));
					  scroll.setViewportView(panelCentroTable);
					  PanelCentro.add(scroll);
				}
				
				dialog.dispose();
			});
	  });
	  
	  
	  
	  atletiFromPalestra.addActionListener(e->{
		JDialog dialog = new JDialog();
		JPanel dialogPanel = new JPanel(new GridLayout(3,2));

		dialog.setLocation((int)dim.getWidth()/2 - dialog.getSize().width/2,(int)dim.getHeight()/2-dialog.getSize().height/2);
		
		JLabel area1 = new JLabel ("Nome Palestra:");
		JTextField text1 = new JTextField ();
		JTextField text2 = new JTextField();
		JLabel area2 = new JLabel ("CittÃ  Palestra:");
		JButton cerca = new JButton ("Enter");
		dialog.add(dialogPanel);
		dialogPanel.add(area1);
		dialogPanel.add(area2);
		dialogPanel.add(text1);
		dialogPanel.add(text2);
		dialogPanel.add(cerca);
		dialog.setVisible(true);
		dialog.pack();
		
		cerca.addActionListener(i->{
			
			  List<Athletes> athlet2 = athlets.getAthletesByGym( text1.getText(),  text2.getText());
			  panelCentroTable.removeAll();
			  for (Athletes a : athlet2) {
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel(" Dati atleta" + " " + (athlet2.indexOf(a)+1)));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel(" Nome:"));
				  panelCentroTable.add(new JLabel(" "+a.getName()));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel(" Cognome:"));
				  panelCentroTable.add(new JLabel(" "+a.getSurname()));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel(" Codice fiscale:"));
				  panelCentroTable.add(new JLabel(" "+a.getCf()));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel(" Citta palestra:"));
				  panelCentroTable.add(new JLabel(" "+a.getGymCity()));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel(" Sesso:"));
				  panelCentroTable.add(new JLabel(" "+a.getSex()));
				  panelCentroTable.add(new JLabel(""));
				  panelCentroTable.add(new JLabel(" Nome palestra:"));
				  panelCentroTable.add(new JLabel(" "+a.getGymName()));
				  panelCentroTable.add(new JLabel("-------"));
				  scroll.setViewportView(panelCentroTable);
				  PanelCentro.add(scroll);
				  System.out.println("Nome atleta: "+a.getName()+", Cognome atleta: "+a.getSurname()+", CF atleta: "+a.getCf());
			
			  }

			  dialog.dispose();
		});
		
		
	  });
	  
	  risultati.addActionListener(e->{
		  
		  panelCentroTable.removeAll();
		  List<Category> catList = category.getCategories();
		  
		  panelCentroTable.add(new JLabel("risultati tutte le categorie :"));
		  for (Category c : catList) {
			  panelCentroTable.add(new JLabel("---------"));
			  panelCentroTable.add(new JLabel("Categoria: "+c.getCategoryName()));
			  panelCentroTable.add(new JLabel(""));
			  panelCentroTable.add(new JLabel("vincitore :"));
			  panelCentroTable.add(new JLabel(""));
			  panelCentroTable.add(new JLabel(""+PerformanceTable.getInstance().getBestAthlet(c.getCategoryName()).getCf()+""));
			  panelCentroTable.add(new JLabel(""));
			  
			  panelCentroTable.add(new JLabel(""+PerformanceTable.getInstance().getBestVote(PerformanceTable.getInstance().getBestAthlet(c.getCategoryName()).getCf())));
			  scroll.setViewportView(panelCentroTable);
		  }
		  
		  
		  
	  });
	  
	  
	  change.addActionListener(e -> {
		  if (aggPalestra.isEnabled()) {
			  gym.updateGym(new String[]{text[0].getText(), text[1].getText(), text[2].getText(), text[3].getText()});
		  }
		  
		  if (aggAtleti.isEnabled()) {
			  athlets.updateAthlet(new String[]{text[0].getText(), text[1].getText(), text[2].getText(), text[3].getText(),
	    				text[4].getText(), text[5].getText(), text[6].getText(), text[7].getText(), text[8].getText(),
	    				text[9].getText()});
		  }
		  
		  if (aggGara.isEnabled()) {
			  competition.updateCompetition(new String[]{text[0].getText(), text[1].getText(), text[2].getText(), text[3].getText()});
		  }
	  });
	  
	  add.addActionListener(e->{
	    try {
	    	if (aggPalestra.isEnabled()) {
	    		gym.insertNewGym(new String[]{text[0].getText(), text[1].getText(), text[2].getText(), text[3].getText()});

	    	}
	
	    	if (aggAtleti.isEnabled()) {
	    		String[] datas = new String[]{text[0].getText(), text[1].getText(), text[2].getText(), text[3].getText(),
	    				text[4].getText(), text[5].getText(), text[6].getText(), text[7].getText(), text[8].getText(),
	    				text[9].getText()};
	    		athlets.insertNewAthlet(datas);
	    	}
	    	
	    	if (aggKata.isEnabled()) {
	    		kata.insertNewKata(text[0].getText());
	    	}
	    	
	    	if (aggGiudice.isEnabled()) {
	    		judge.insertNewJudge(new String[]{text[0].getText(),text[1].getText(),text[2].getText(),
	    				text[3].getText(),text[4].getText(),text[5].getText(),text[6].getText()});
	    	}
	    	
	    	if (aggCategoria.isEnabled()) {
	    		System.out.println("AGGCATEGORY");
	    		category.insertNewCategory(text[0].getText());
	    	}
	    	
	    	if (aggArbitro.isEnabled()) {
	    		refree.insertNewRefree(new String[]{text[0].getText(), text[1].getText(), text[2].getText(), text[3].getText(),
	    				text[4].getText(), text[5].getText(), text[6].getText()});
	    	}
	    	
	    	if (aggTavoloGiuria.isEnabled()) {
	    		jury.insertNewJury(new String(text[0].getText()));
	    	}
	    	
	    	if (aggTatami.isEnabled()) {
	    		tatami.insertNewTatami(new String[]{text[0].getText(), text[1].getText(), text[2].getText(), text[3].getText()});
	    	}
	    	
	    	if (aggProva.isEnabled()) {
	    		performance.insertNewPerformance(new String[]{text[0].getText(), text[1].getText(), text[2].getText(), text[3].getText(),
	    								text[4].getText(), text[5].getText(), text[6].getText()});
	    	}
	    	
	    	if (aggGara.isEnabled()) {
	    		competition.insertNewCompetition(new String[]{text[0].getText(), text[1].getText(), text[2].getText(), text[3].getText()});
	    	}
	    	
	    	if (aggGiudiceInTavoloGiuria.isEnabled()) {
	    		jjtable.insertNewJudgeJuryTable(text[0].getText(), text[1].getText());
	    	}
	    	
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	    
	    reset();
	  });
	  
	  
	  reset.addActionListener(e->{
		  reset();
	  });
	  
	  
	  remove.addActionListener(e->{
		   try {
		    	if (aggPalestra.isEnabled()) {
		    		//chiave mista palestra
		    		GymTable.getInstance().delete(text[2].getText(),text[3].getText());
		    	}
		
		    	if (aggAtleti.isEnabled()) {
		    		athletTable.getInstance().deleteAthlet(text[4].getText());
		    	}	
		    	if (aggKata.isEnabled()) {
		    		KataTable.getInstance().delete(text[0].getText());
		    	}
		    	if(aggGara.isEnabled()){
		    		CompetitionTable.getInstance().delete(text[0].getText(),text[2].getText(),text[3].getText());
		    	}
		    	
		    	if(aggArbitro.isEnabled()){
		    		RefreeTable.getInstance().delete(text[4].getText());
		    	}
		    	if (aggCategoria.isEnabled()) {
		    		CategoryTable.getInstance().delete(text[0].getText());
		    	}
		    	if (aggGiudice.isEnabled()) {
		    		JudgeTable.getInstance().deleteJudge(text[4].getText());
		    	}
		    	if(aggProva.isBorderPainted()){
		    		
		    	}
		    	if(aggProva.isEnabled()){
		    		PerformanceTable.getInstance().delete(text[0].getText(),text[1].getText(),text[2].getText());
		    	}
		    	if(aggTatami.isEnabled()){
		    		TatamiTable.getIntance().delete(text[2].getText());
		    	}
		    	
		    	if(aggGiudiceInTavoloGiuria.isEnabled()){
		    		JudgeJuryTable.getInstance().delete(text[0].getText(),text[1].getText());
		    	}
		    	
		    	if(aggTavoloGiuria.isEnabled()){
		    		JudgeTable.getInstance().deleteJudge(text[0].getText());
		    	}
		    	
		    	
			} catch (Exception e1) {
				e1.printStackTrace();
			}
		    
		   
		  reset();
	  });
	}
	
	
	
	
	public void inizializza(JButton visible,String[] campi){
	  for(int i = 0 ; i<campi.length;i++){
		  label[i].setText(campi[i]);
		  label[i].setVisible(true);
		  text[i].setVisible(true);
	  }
	  for(int i = campi.length; i<10;i++){
		  label[i].setVisible(false);
	      text[i].setVisible(false);
	  }

	  if(root){
	  	add.setEnabled(true);
		change.setEnabled(true);
		remove.setEnabled(true);
	  }

		aggPalestra.setEnabled(false);
		aggAtleti.setEnabled(false);
		aggArbitro.setEnabled(false);
		aggTavoloGiuria.setEnabled(false);
		aggKata.setEnabled(false);
		aggGara.setEnabled(false);
		aggGiudice.setEnabled(false);
		aggTatami.setEnabled(false);
		aggProva.setEnabled(false);
		aggCategoria.setEnabled(false);
		aggGiudiceInTavoloGiuria.setEnabled(false);

		visible.setEnabled(true);
	  }

	
	public boolean isInteger(String s) {
	    try { 
	        Integer.parseInt(s); 
	    } catch(NumberFormatException e) { 
	        return false; 
	    } catch(NullPointerException e) {
	        return false;
	    }
	    return true;
	}
	
	public void reset(){

		  for(int i =0; i<10;i++){
			  label[i].setVisible(false);
			  text[i].setText("");
		      text[i].setVisible(false);
		  }
		  
		  panelCentroTable.removeAll();
		  
		  	aggPalestra.setEnabled(true);
			aggAtleti.setEnabled(true);
			aggArbitro.setEnabled(true);
			aggKata.setEnabled(true);
			aggGiudice.setEnabled(true);
			aggTavoloGiuria.setEnabled(true);
			aggGara.setEnabled(true);
			aggGiudice.setEnabled(true); 
			aggTatami.setEnabled(true);
			aggProva.setEnabled(true);
			aggCategoria.setEnabled(true);
			aggGiudiceInTavoloGiuria.setEnabled(true);			
			eraseCenter();
			
			if(root){
			add.setEnabled(false);
			change.setEnabled(false);
			remove.setEnabled(false);
			}
	}
	
	public void eraseCenter(){
		scroll.setVisible(false);
		FindDescrition.setVisible(false);
		atletiFromPalestra.setVisible(false);
		dettagliGaraAtleta.setVisible(false);
		atletiCFDaNome.setVisible(false);
		giudiceDaCF.setVisible(false);
		tutteCategorie.setVisible(false); 
		tuttiKata.setVisible(false);
		tuttaGiuria.setVisible(false);
		nomePalestraDaCittà.setVisible(false);
		contaAtletiCategoria.setVisible(false);
		giudiceInGiuria.setVisible(false);
		atletiSuTatami.setVisible(false);
		nomeManifestazioneDaPalestra.setVisible(false);
		sommaVoti.setVisible(false);
		risultati.setVisible(false);
	}
	
	public void showCenter(){
		scroll.setVisible(true);
		FindDescrition.setVisible(true);
		atletiFromPalestra.setVisible(true);
		dettagliGaraAtleta.setVisible(true);
		tutteCategorie.setVisible(true);
		atletiCFDaNome.setVisible(true);
		giudiceDaCF.setVisible(true);
		tuttiKata.setVisible(true);
		tuttaGiuria.setVisible(true); 
		nomePalestraDaCittà.setVisible(true);
		contaAtletiCategoria.setVisible(true);
		giudiceInGiuria.setVisible(true);
		atletiSuTatami.setVisible(true);
		nomeManifestazioneDaPalestra.setVisible(true);
		sommaVoti.setVisible(true);
		risultati.setVisible(true);
	  for(int i =0; i<10;i++){
		  label[i].setVisible(false);
	      text[i].setVisible(false);
	      text[i].setText("");
	  }
	  	aggPalestra.setEnabled(true);
		aggAtleti.setEnabled(true);
		aggArbitro.setEnabled(true);
		aggTavoloGiuria.setEnabled(true);
		aggGiudice.setEnabled(true);
		aggKata.setEnabled(true);
		aggGara.setEnabled(true);
		aggTatami.setEnabled(true);
		aggProva.setEnabled(true);
		aggCategoria.setEnabled(true);
		aggGiudiceInTavoloGiuria.setEnabled(true);
	}
	
	
	
}
