package tables;

import java.sql.*;
import java.util.ArrayList;
import java.util.List;

import javax.sql.*;

import database_connection.DBMySQLConnection;

public class GymTable {

	private final DBMySQLConnection dbConnection;
	
	private final String tableName = "palestra";
	private PreparedStatement statement;
	
	private List<Gym> gymList = new ArrayList<>();
	
	public GymTable() {
		dbConnection = new DBMySQLConnection();
	}
	
	public void insertNewGym(final String[] datas) {
		dbConnection.connectionToDatabase();
		try {
			String sqlString = "INSERT INTO "+tableName+"(numero_posti_spettatori,indirizzo,nome,città) VALUES(?,?,?,?)";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			
			String seats = datas[0].toString();
			String address = datas[1].toString();
			String name = datas[2].toString();
			String city = datas[3].toString();
			
			statement.setInt(1, Integer.parseInt(seats));
			statement.setString(2, datas[1].toString());
			statement.setString(3, datas[2].toString());
			statement.setString(4, datas[3].toString());
			statement.executeUpdate();
			statement.close();
			dbConnection.getConnection().close();
			
			Gym gym = new Gym();
			gym.setGymName(name);
			gym.setGymCity(city);
			gym.setAddress(address);
			gym.setSeats(seats);
			
			gymList.add(gym);
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public List<String> getGymsByCity(final String inputCity) {
		List<String> listgym = new ArrayList<>();
		try {
			dbConnection.connectionToDatabase();
			int i=0;
			String sqlString = "SELECT DISTINCT nome FROM "+tableName+" WHERE città='"+inputCity+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				String s = result.getString("nome");
				listgym.add(s);
				i++;
			}
			statement.close();
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return listgym;
	}
	
	public Gym getGymByNameAndCity(final String inputName, final String inputCity) {
		dbConnection.connectionToDatabase();
		Gym gym = null;
		try {
			String sqlString = "SELECT * FROM "+tableName+" WHERE nome = '"+inputName+"' AND città='"+inputCity+"'";
			PreparedStatement statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			if (result.next()) {
				gym = new Gym();
				gym.setSeats(result.getString("numero_posti_spettatori"));
				gym.setAddress(result.getString("indirizzo"));
				gym.setGymName(result.getString("nome"));
				gym.setGymName(result.getString("città"));
			}
			statement.close();
			dbConnection.getConnection().close();
			
			
		} catch(Exception e) { 
			e.printStackTrace();
		}
		
		return gym;
	}
	
	public void updateGym(final String[] datas) {
		try {
			openConnection();
			String seats = datas[0].toString();
			String address = datas[1].toString();
			String name = datas[2].toString();
			String city = datas[3].toString();
			String sqlString = "UPDATE "+tableName+" SET numero_posti_spettatori="+seats+" , indirizzo='"+address+"' WHERE nome='"+name+"' AND città='"+city+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			statement.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void delete(String input, String input2) {
		try {
			openConnection();
			String sqlString = "DELETE FROM "+tableName+" WHERE nome='"+input+"' AND città='"+input2+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	public static GymTable getInstance() {
		return new GymTable();
	}
}
