package tables;

import java.sql.*;

import javax.sql.*;

import database_connection.DBMySQLConnection;

import java.util.*;

public class JuryTable {

	private List<Jurydesk> deskList = new ArrayList<>();
	private DBMySQLConnection dbConnection = new DBMySQLConnection();
	private PreparedStatement statement;
	private String tableName = "tavolo_di_giuria";
	
	public JuryTable() {
		
	}
	
	public void insertNewJury(final String inputCode) {
		try {
			openConnection();
			String sqlString = "INSERT INTO "+tableName+"(codice) VALUES(?)";
			statement = dbConnection.getConnection().prepareStatement(sqlString); 
			statement.setString(1, inputCode); 
			statement.executeUpdate();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public List<Jurydesk> getAllDesks() {
		List<Jurydesk> allDesks = new ArrayList<>();
		try {
			openConnection();
			
			String sqlString = "SELECT * FROM "+tableName;
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			
			ResultSet result = statement.executeQuery();
			while (result.next()) {
				Jurydesk desk = new Jurydesk();
				desk.set(result.getString("codice"));
				allDesks.add(desk);
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		
		return allDesks;
	}
	
	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			statement.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public static JuryTable getInstance() {
		return new JuryTable();
	}

	public void delete(String text) {
		try {
			openConnection(); 
			String sqlString = "DELETE FROM "+tableName+" WHERE codice='"+text+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
}
