package tables;

import java.sql.*;

import javax.sql.*;

import java.util.*;

import database_connection.*;

public class RefreeTable {

	private String tableName = "arbitro";
	
	private DBMySQLConnection dbConnection;
	private PreparedStatement statement;
	private List<Refree> refreeList = new ArrayList<>();
	
	public RefreeTable() {
		dbConnection = new DBMySQLConnection();
	}
	
	public void insertNewRefree(final String[] datas) {
		try {
			openConnection();
			String sqlString = "INSERT INTO "+tableName+"(luogo_di_nascita,data_di_nascita,cognome,nome,CF,nomePalestra,cittàPalestra)"+ " VALUES(?,?,?,?,?,?,?)";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			Calendar calendar = Calendar.getInstance();
			
			String location = datas[0].toString();
			String surname = datas[2].toString();
			String name = datas[3].toString();
			String cf = datas[4].toString();
			String gymName = datas[5].toString();
			String gymCity = datas[6].toString();
			
			statement.setString(1, datas[0].toString());
			
			String[] data = datas[1].toString().split("/");
			calendar.set(Integer.parseInt(data[0]), Integer.parseInt(data[1])-1, Integer.parseInt(data[2]));
			java.util.Date date = calendar.getTime();
			statement.setDate(2, new java.sql.Date(date.getTime()));
			
			statement.setString(3, surname);
			statement.setString(4, name);
			statement.setString(5, cf);
			statement.setString(6, gymName);
			statement.setString(7, gymCity);
			
			statement.executeUpdate();
			closeStatement();
			closeConnection();
			
			Refree refree = new Refree();
			refree.setName(name);
			refree.setSurname(surname);
			refree.setBirthDate(date);
			refree.setLocation(location);
			refree.setGymCity(gymCity);
			refree.setGymName(gymName);
			refreeList.add(refree);
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	

	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			statement.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public static RefreeTable getInstance() {
		return new RefreeTable();
	}
	public Refree getRefreeByCf(final String inputCf) {
		Refree refree = null;
		try {
			openConnection();
			String sqlString = "SELECT * FROM "+tableName+" WHERE CF = '"+inputCf+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			ResultSet result = statement.executeQuery();
			if (result.next()) {
				refree = new Refree();
				long secs;
				java.util.Date birthDate;
				refree.setLocation(result.getString("luogo_di_nascita"));
				secs = result.getDate("data_di_nascita").getTime();
                birthDate = new java.util.Date(secs);
                refree.setBirthDate(birthDate);
                refree.setName(result.getString("nome"));
                refree.setSurname(result.getString("cognome"));
                refree.setCf(result.getString("CF"));
                refree.setGymName(result.getString("nomePalestra"));
                refree.setGymCity(result.getString("cittàPalestra"));
			}
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
		return refree;
	}
	

	public void delete(String text) {
		try {
			openConnection();
			String sqlString = "DELETE FROM "+tableName+" WHERE CF='"+text+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
}
