package tables;

import java.sql.*;

import javax.sql.*;

import java.util.*;

import database_connection.*;


public class TatamiTable {

	private static final String tableName = "tatami";
	private DBMySQLConnection dbConnection = new DBMySQLConnection();
	private PreparedStatement statement;
	private List<Tatami> tatamiList = new ArrayList<>();
	
	public TatamiTable() {
		
	}
	
	public void insertNewTatami(final String[] datas) {
		try {
			
			String gymName = datas[0].toString();
			String gymCity = datas[1].toString();
			String code = datas[2].toString();
			String juryTableCode = datas[3].toString();
			
			if (GymTable.getInstance().getGymByNameAndCity(gymName, gymCity) != null) {
				List<Jurydesk> list = JuryTable.getInstance().getAllDesks();
				for (Jurydesk j : list) {
					if (j.getCode().equals(juryTableCode)) {
						openConnection();
						String sqlString = "INSERT INTO "+tableName+"(nomePalestra,cittàPalestra,codice,codiceTavoloGiuria) VALUES(?,?,?,?)";
						statement = dbConnection.getConnection().prepareStatement(sqlString); 
						statement.setString(1, gymName);
						statement.setString(2, gymCity);
						statement.setString(3, code);
						statement.setString(4, juryTableCode);
						statement.executeUpdate();
						
						closeStatement();
						closeConnection();
						
						Tatami tatami = new Tatami();
						tatami.setCode(code);
						tatami.setGymCity(gymCity);
						tatami.setGymName(gymName);
						tatami.setGiuryTableCode(juryTableCode);
						tatamiList.add(tatami);
					}
				}
			} else {
				System.out.println("Impossibile aggiungere il tatami. La palestra non esiste nel Database.");
			}
			
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void openConnection() {
		try {
			dbConnection.connectionToDatabase();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeConnection() {
		try {
			dbConnection.getConnection().close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void closeStatement() {
		try {
			 statement.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void delete(String input) {
		try {
			openConnection();
			String sqlString = "DELETE FROM "+tableName+" WHERE codice='"+input+"'";
			statement = dbConnection.getConnection().prepareStatement(sqlString);
			statement.execute();
			closeStatement();
			closeConnection();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	public static TatamiTable getIntance() {
		// TODO Auto-generated method stub
		return new TatamiTable();
	}
}
